program ImageManagerTest;
uses HeapTrc, SysUtils, SDL, ImageManager;
const
   BackgroundFile = '../pascal-progs2/background.bmp';
   BallFile = '../pascal-progs2/ball.bmp';
   pixX = 200; pixY = 200;
var
   screen : PSDL_Surface = nil;
   background : PSDL_Surface = nil;
   ball : PSDL_Surface = nil;
   SrcRect, DstRect : SDL_Rect;
begin
   ImageManager.RaiseOnError := True;
   try try
      if SDL_Init(SDL_INIT_VIDEO) < 0 then
         raise Exception.Create ('Couldn''t initialize SDL');
      background := LoadImage (BackgroundFile);
      screen := SDL_SetVideoMode(background^.w, background^.h,
                                 background^.format^.BitsPerPixel,
                                 SDL_SWSURFACE);
      if screen = nil then
         raise Exception.Create ('Couldn''t set video mode');
      ball := LoadImage (BallFile);
      if SDL_BlitSurface(background, nil, screen, nil) < 0 then
         raise Exception.Create ('BlitSurface background error');
      with SrcRect do begin
         x := 0; y := 0; w := ball^.w; h := ball^.h
      end;
      with DstRect do begin
         x := pixX; y := pixY; w := pixX + ball^.w; h := pixY + ball^.h
      end;
      if SDL_BlitSurface (ball, @SrcRect, screen, @DstRect) < 0 then
         raise Exception.Create ('BlitSurface ball error');
      SDL_Flip (screen);
      ReadLn;
   except
      on E: EImageManager do
         WriteLn ('ERROR Loading: ', E.Message);
      on E: Exception do
         WriteLn ('ERROR: ', E.Message, ' -- ', SDL_GetError);
   end
   finally
      if screen <> nil then SDL_FreeSurface(screen);
      SDL_Quit
   end
end.