{Overlay an image over a background; handle errors.}
program ImageSDLExn;
uses SysUtils, SDL, SDL_image;
const
   BackgroundFile = '../pascal-progs2/background.bmp';
   BallFile = '../pascal-progs2/ball.bmp';
   pixX = 200; pixY = 200;
var
   screen : PSDL_Surface = nil;
   background : PSDL_Surface = nil;
   ball : PSDL_Surface = nil;
   SrcRect, DstRect : SDL_Rect;
begin
   WriteLn ('Initializing SDL.');
   try try
      if SDL_Init(SDL_INIT_VIDEO) < 0 then
         raise Exception.Create ('Couldn''t initialize SDL');
      background := IMG_Load (BackgroundFile);
      if background = nil then
         raise Exception.Create ('Couldn''t load ' + BackgroundFile);
      screen := SDL_SetVideoMode(background^.w, background^.h,
                                 background^.format^.BitsPerPixel,
                                 SDL_SWSURFACE);
      if screen = nil then
         raise Exception.Create ('Couldn''t set video mode');
      ball := IMG_Load (BallFile);
      if ball = nil then
         raise Exception.Create ('Couldn''t load ' + BallFile);

      if SDL_BlitSurface(background, nil, screen, nil) < 0 then
         raise Exception.Create ('BlitSurface background error');
      with SrcRect do begin
         x := 0; y := 0; w := ball^.w; h := ball^.h
      end;
      with DstRect do begin
         x := pixX; y := pixY; w := pixX + ball^.w; h := pixY + ball^.h
      end;
      if SDL_BlitSurface (ball, @SrcRect, screen, @DstRect) < 0 then
         raise Exception.Create ('BlitSurface ball error');
      SDL_Flip (screen);
      ReadLn;
   except
      on E: Exception do
         WriteLn ('ERROR: ', E.Message, ' -- ', SDL_GetError);
   end
   finally
      if background <> nil then SDL_FreeSurface(background);
      if ball <> nil then SDL_FreeSurface(ball);
      if screen <> nil then SDL_FreeSurface(screen);
      SDL_Quit
   end
end.